function plotVectorField(self,V,varargin)
  % Color is set by a function u on poit x,y,z
  p = inputParser; 
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('freq',1,@isscalar); % plot frequence
  p.addParamValue('scale',1,@isscalar); % plot frequence
  p.addParamValue('colordata',[],@isnumeric); 
  p.parse(varargin{:});
  R=p.Results;
  scale=R.scale;u=R.colordata;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  I=1:R.freq:self.nq;
  %rndIDX = randperm(self.nq); 
  %I=rndIDX(1:fix(self.nq/R.freq));
  Ig=self.toParent(I);
  if iscell(V),getVcomp=@(i,I) V{i}(I);
  elseif size(V,1)==self.dim
    getVcomp=@(i,I) V(i,I);
  else
    getVcomp=@(i,I) V(I,i)';
  end
  
  if self.dim==2
%      extern.vfield_color.vfield(self.q(1,:),self.q(2,:), ...
%                  scale*V(1,self.toGlobal),scale*V(2,self.toGlobal),u(self.toGlobal))
    if isempty(u)
      quiver(self.q(1,I),self.q(2,I),getVcomp(1,Ig),getVcomp(2,Ig),varargin{:});
    else
      fc_tools.graphics.vfield3.vfield3(self.q(1,I),self.q(2,I),zeros(1,length(I)), ...
         scale*getVcomp(1,Ig),scale*getVcomp(2,Ig),zeros(1,length(I)),u(Ig),varargin{:});
    end
  end
  if self.dim==3
    if isempty(u)
       quiver3(self.q(1,I),self.q(2,I),self.q(3,I),getVcomp(1,Ig),getVcomp(2,Ig),getVcomp(3,Ig),varargin{:});
    else  
%        whos
%        u(I)
%        getVcomp(3,Ig)
      fc_tools.graphics.vfield3.vfield3(self.q(1,I),self.q(2,I),self.q(3,I), ...
         scale*getVcomp(1,Ig),scale*getVcomp(2,Ig),scale*getVcomp(3,Ig),u(Ig),varargin{:});
    end
  end
end
